'**************************************************************************
'PGL - QUICK BASIC DECLARATIONS
'Copyright (c) 1991 AnSoft, Inc.
'Basic Interface to PGL
'Quick Basic 4.0,4.5
'Basic Prof Dev System 7.x
'**************************************************************************
'	Page Orientation  constants
CONST pgPORTRAIT  =0
CONST pgLANDSCAPE =1

'	Page Size  constants
CONST pgHALFPAGE  =0
CONST pgFULLPAGE  =1
CONST pgSMALLPAGE =2

'	Device Type  constants
CONST pgDOTMATRIX =0
CONST pgLASERJET  =1
CONST pgPCX       =2
CONST pgEPS       =3

'	Printer ON/OFF definition constants
CONST  pgOFF =0
CONST  pgON  =1

'	Line style definition constants
CONST  pgLSOLID     = 0
CONST  pgLHUGEDASH  = 1
CONST  pgLBIGDASH   = 2
CONST  pgLMEDDASH   = 3
CONST  pgLSMALLDASH = 4
CONST  pgLWIDEDOT   = 5
CONST  pgLCLOSEDOT  = 6
CONST  pgLDASHDOT   = 7
CONST  pgLCENTER    = 8

'	Fill Style Definition constants
CONST  pgFEMPTY      =0
CONST  pgFSOLID      =1
CONST  pgFLINE       =2
CONST  pgFLTSLASH    =3
CONST  pgFSLASH      =4
CONST  pgFBKSLASH    =5
CONST  pgFLTBKSLASH  =6
CONST  pgFHATCH      =7
CONST  pgFXHATCH     =8
CONST  pgFINTERLEAVE =9
CONST  pgFWIDEDOT    =10
CONST  pgFCLOSEDOT   =11

'       Fill Mode 
CONST  pgTRANS	     =0
CONST  pgOPAQ	     =1

'	Text Justification  constants
CONST pgLEFT    =0
CONST pgCENTER	=1
CONST pgRIGHT   =2
CONST pgBOTTOM	=0
CONST pgTOP     =2

'	Font Style constants
CONST pgSMALL    =0
CONST pgSIMPLEX  =1
CONST pgDUPLEX   =2
CONST pgTRIPLEX  =3
CONST pgGOTHIC   =4
CONST pgSCRIPT   =5
CONST pgSDUPLEX  =6
      
'	Fill Flag constants
CONST pgOUTLINE =1
CONST pgFILL    =2
CONST pgOFILL   =3        

' Printer Driver Device Info 
DECLARE FUNCTION pgLoadDevInfo% ( SEG name$ )

' Functions to Set Printer Driver Params 
DECLARE SUB pgSetPageMargins  ( BYVAL left%, BYVAL top%, BYVAL right%, BYVAL bot% )
DECLARE SUB pgSetPageForm     ( BYVAL form% )
DECLARE SUB pgSetPageSize     ( BYVAL size% )

' Functions to save bitmaps
DECLARE SUB pgBMInit ( BYVAL x%, BYVAL y%, BYVAL wid%, BYVAL hght%, BYVAL bpp%, BYVAL rle% )
DECLARE SUB pgBMData ( BYVAL row%, SEG rowdata% )
DECLARE SUB pgBMEnd  ( )


' Functions To Get Info About Current Driver - Res Independent
DECLARE FUNCTION  pgGetDevModes%    
DECLARE FUNCTION  pgGetDevType%      
DECLARE FUNCTION  pgGetDevHeight%    
DECLARE FUNCTION  pgGetDevWidth%     
DECLARE FUNCTION  pgGetDevOffsetX%   
DECLARE FUNCTION  pgGetDevOffsetY%  

' Functions To Get Info About Current Driver - Res Dependent
DECLARE FUNCTION  pgGetDevColors%    ( BYVAL res% )
DECLARE FUNCTION  pgGetDevMaxX%      ( BYVAL res% )
DECLARE FUNCTION  pgGetDevMaxY%      ( BYVAL res% )
DECLARE FUNCTION  pgGetDevResX%      ( BYVAL res% )
DECLARE FUNCTION  pgGetDevResY%      ( BYVAL res% )
DECLARE FUNCTION  pgGetDevPlanes%    ( BYVAL res% )

' PGL System Functions
DECLARE SUB      pgInitDrw   ( SEG name$, BYVAL wid%, BYVAL hght%, SEG ierr% )
DECLARE SUB      pgOpenDrw   ( SEG name$, SEG ierr%)   
DECLARE SUB      pgClearDrw  ( SEG ierr% ) 
DECLARE SUB      pgEndDrw    ( )
DECLARE SUB      pgNewPage   ( )
DECLARE FUNCTION pgGetStatus%

' PGL Graphics Functions  
DECLARE SUB pgMoveTo       ( BYVAL x%, BYVAL y% )
DECLARE SUB pgMoveRel      ( BYVAL x%, BYVAL y% )
DECLARE SUB pgLineTo       ( BYVAL x%, BYVAL y% )
DECLARE SUB pgLineRel      ( BYVAL x%, BYVAL y% )
DECLARE SUB pgLine         ( BYVAL x1%, BYVAL y1%, BYVAL x2%, BYVAL y2% )
DECLARE SUB pgSetPixel     ( BYVAL x%, BYVAL y%, BYVAL clr% )
DECLARE SUB pgArc          ( BYVAL x%, BYVAL y%, BYVAL rad%, BYVAL sa%, BYVAL ea% )
DECLARE SUB pgEllArc       ( BYVAL x%, BYVAL y%, BYVAL radx%, BYVAL rady%, BYVAL sa%, BYVAL ea% )
DECLARE SUB pgPie          ( BYVAL x%,BYVAL y%,BYVAL rad%,BYVAL sa%,BYVAL ea%, BYVAL fillflag% )
DECLARE SUB pgSector       ( BYVAL x%,BYVAL y%,BYVAL rx%,BYVAL ry%,BYVAL sa%,BYVAL ea%,BYVAL fillflag%)
DECLARE SUB pgRectangle    ( BYVAL x1%,BYVAL y1%,BYVAL x2%,BYVAL y2%,BYVAL fillflag%)
DECLARE SUB pgCircle       ( BYVAL x%,BYVAL y%,BYVAL rad%,BYVAL fillflag% )
DECLARE SUB pgEllipse      ( BYVAL x%,BYVAL y%,BYVAL rx%,BYVAL ry%, BYVAL fillflag%)
DECLARE SUB pgPolygon      ( SEG polydata%, BYVAL npts%, BYVAL fillflag% )
DECLARE SUB pgPolyLine     ( SEG polydata%, BYVAL npts% )
DECLARE SUB pgDrawText     ( SEG text$ )
DECLARE SUB pgDrawTextXY   ( BYVAL x%,BYVAL y%, SEG text$ )
DECLARE SUB pgClearViewPort( )

' PGL Functions to Set Graphics Parameters 
DECLARE SUB pgSetColor        ( BYVAL clr% ) 
DECLARE SUB pgSetPalette      ( BYVAL index%,BYVAL clr% ) 
DECLARE SUB pgSetRgbPalette   ( BYVAL index%, BYVAL red%, BYVAL green%, BYVAL blue% )
DECLARE SUB pgSetDefaults     ( )   
DECLARE SUB pgSetFillMode     ( BYVAL mode% )
DECLARE SUB pgSetFillStyle    ( BYVAL style%, BYVAL clr% ) 
DECLARE SUB pgSetFillPattern  ( SEG style%, BYVAL clr% ) 
DECLARE SUB pgSetLineStyle    ( BYVAL style%, BYVAL thick% ) 
DECLARE SUB pgSetLineWeight   ( BYVAL weight% )
DECLARE SUB pgSetLinePattern  ( BYVAL pat%, BYVAL thick% ) 
DECLARE SUB pgSetTextBolding  ( BYVAL thick% ) 
DECLARE SUB pgSetCharSpacing  ( BYVAL space% )
DECLARE SUB pgSetTextScaling  ( BYVAL mx%,BYVAL dx%,BYVAL my%,BYVAL dy%  ) 
DECLARE SUB pgSetTextSize     ( BYVAL size% ) 
DECLARE SUB pgSetTextJustify  ( BYVAL horiz%, BYVAL vert% ) 
DECLARE SUB pgSetTextOrient   ( BYVAL ox%,BYVAL oy%  ) 
DECLARE SUB pgSetTextStyle    ( BYVAL fontno% ) 
DECLARE SUB pgSetClipArea     ( BYVAL cx1%,BYVAL cy1%,BYVAL cx2%,BYVAL cy2% )
DECLARE SUB pgSetClipping     ( BYVAL flag% ) 
DECLARE SUB pgSetPrn          ( BYVAL flag% ) 
DECLARE SUB pgSetViewPort     ( BYVAL x1%,BYVAL y1%,BYVAL x2%,BYVAL y2% )

' PGL Functions to Get Graphics Parameters 
DECLARE FUNCTION  pgGetColor%
DECLARE FUNCTION  pgGetFillMode%
DECLARE SUB       pgGetFillPattern  ( SEG style%, SEG clr% ) 
DECLARE SUB       pgGetFillStyle    ( SEG style%, SEG clr% )
DECLARE SUB       pgGetLineStyle    ( SEG style%, SEG thick% ) 
DECLARE SUB       pgGetLinePattern  ( SEG pat%, SEG thick% ) 
DECLARE FUNCTION  pgGetLineWeight%
DECLARE FUNCTION  pgGetMaxX%         
DECLARE FUNCTION  pgGetMaxY%
DECLARE FUNCTION  pgGetTextBolding%
DECLARE FUNCTION  pgGetCharSpacing%
DECLARE SUB       pgGetTextScaling  ( SEG mx%, SEG dx%, SEG my%, SEG dy%) 
DECLARE SUB       pgGetTextJustify  ( SEG horiz%, SEG vert%) 
DECLARE SUB       pgGetTextOrient   ( SEG ox%, SEG oy% ) 
DECLARE FUNCTION  pgGetTextStyle%      
DECLARE SUB       pgGetClipArea     ( SEG cx1%, SEG cy1%, SEG cx2% , SEG cy2% )
DECLARE FUNCTION  pgGetClipping%
DECLARE FUNCTION  pgGetPrn%
DECLARE FUNCTION  pgGetTextHeight%
DECLARE FUNCTION  pgGetX%
DECLARE FUNCTION  pgGetY%
DECLARE FUNCTION  pgGetAbsX%
DECLARE FUNCTION  pgGetAbsY%
DECLARE FUNCTION  pgGetTextLength% ( SEG text$ )
DECLARE SUB       pgGetViewPort    ( SEG x1%, SEG y1%, SEG x2%, SEG y2% )
	
